import { __awaiter, __decorate, __param } from "tslib";
import { DI } from '@microsoft/fast-foundation';
import { Serializer } from './serializers';
let HttpService = class HttpService {
    constructor(serializer) {
        this.serializer = serializer;
    }
    get(url, requestInit) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield fetch(url, Object.assign(Object.assign({}, requestInit), { method: 'GET' }));
            const serializer = requestInit.serializer || this.serializer;
            return serializer.deserialize(response);
        });
    }
    post(url, requestInit) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield fetch(url, Object.assign(Object.assign({}, requestInit), { method: 'POST' }));
            const serializer = requestInit.serializer || this.serializer;
            return serializer.deserialize(response);
        });
    }
};
HttpService = __decorate([
    __param(0, Serializer)
], HttpService);
/**
 * The DI token for the Http interface.
 * @internal
 */
export const Http = DI.createInterface((x) => x.singleton(HttpService));
