<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-comms](./foundation-comms.md)

## foundation-comms package

## Classes

|  Class | Description |
|  --- | --- |
|  [AuthError](./foundation-comms.autherror.md) | Represents an error that occurs during authentication. |
|  [CurrentUser](./foundation-comms.currentuser.md) | Represents the current user (i.e. the user that is currently logged in). |
|  [DatasourceDefaults](./foundation-comms.datasourcedefaults.md) | Default values for a DatasourceConfig |
|  [DefaultConnect](./foundation-comms.defaultconnect.md) | The Connect implementation for WebSocket. |
|  [DefaultDatasource](./foundation-comms.defaultdatasource.md) | DefaultDatasource. |
|  [SocketMessageHandler](./foundation-comms.socketmessagehandler.md) | The Socket message handler definition. |
|  [SocketObservable](./foundation-comms.socketobservable.md) | Observable that wraps a WebSocketSubject and provides an Observable interface for sending and receiving messages. |
|  [SocketSubject](./foundation-comms.socketsubject.md) | Subject that wraps a WebSocketSubject and provides a Subject interface for sending and receiving messages. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [AuthType](./foundation-comms.authtype.md) | The available ypes of authentication. |
|  [EventMessageType](./foundation-comms.eventmessagetype.md) | Event Message types |
|  [FieldTypeEnum](./foundation-comms.fieldtypeenum.md) | Available types for a field metadata. |
|  [FoundationAnalyticsEventType](./foundation-comms.foundationanalyticseventtype.md) | Analytics event types |
|  [MessageCode](./foundation-comms.messagecode.md) | General Message codes |
|  [MessageType](./foundation-comms.messagetype.md) | General Message types |
|  [ResourceType](./foundation-comms.resourcetype.md) | Types of Genesis resources. |
|  [SocketReconnectStrategy](./foundation-comms.socketreconnectstrategy.md) | Socket reconnection strategies |

## Functions

|  Function | Description |
|  --- | --- |
|  [criteriaFiltersToFields(filters)](./foundation-comms.criteriafilterstofields.md) | Criteria filters to fields. |
|  [dataServerResultFilter(result, rowId)](./foundation-comms.dataserverresultfilter.md) | Data server result filter. |
|  [normaliseCriteria(criteria, delimiter)](./foundation-comms.normalisecriteria.md) | Normalise criteria. |
|  [until(conditionFunc, timeoutMs)](./foundation-comms.until.md) | Polls a condition function until it returns true or a timeout is reached. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [Auth](./foundation-comms.auth.md) | Auth is the main interface for authenticating with a Genesis Server endpoint. |
|  [Connect](./foundation-comms.connect.md) | Represents a connection and its capabilities on a remote server Provides methods to send and receive messages, as well as metadata and schema information. |
|  [ConnectConfig](./foundation-comms.connectconfig.md) | Configuration options for the Connect (WS) instance. |
|  [CredentialManager](./foundation-comms.credentialmanager.md) | Represents a system for managing user credentials and authentication tokens. |
|  [CredentialManagerConfig](./foundation-comms.credentialmanagerconfig.md) | The configuration for the CredentialManager |
|  [CredentialManagerCookieConfig](./foundation-comms.credentialmanagercookieconfig.md) | The configuration options for the CredentialManager cookie |
|  [Datasource](./foundation-comms.datasource.md) | Datasource interface. |
|  [DatasourceConfig](./foundation-comms.datasourceconfig.md) | The configuration object for a Datasource |
|  [DatasourceOptions](./foundation-comms.datasourceoptions.md) | Options that can be passed when initializing a datasource. |
|  [DataUpdate](./foundation-comms.dataupdate.md) | Data Update definition with details of what data to add, drop, and/or modify. |
|  [Dataview](./foundation-comms.dataview.md) | Dataview object |
|  [FDC3AppIntent](./foundation-comms.fdc3appintent.md) |  |
|  [FDC3Channel](./foundation-comms.fdc3channel.md) |  |
|  [FDC3Context](./foundation-comms.fdc3context.md) |  |
|  [FDC3IntentResolution](./foundation-comms.fdc3intentresolution.md) |  |
|  [FoundationAnalytics](./foundation-comms.foundationanalytics.md) | Represents an analytics tracking system. |
|  [Http](./foundation-comms.http.md) | An interface representing an HTTP client that can make GET and POST requests and return a promise with the response data. |
|  [HttpConnectConfig](./foundation-comms.httpconnectconfig.md) | Configuration options for the Connect (HTTP) instance. |
|  [HttpPollingConfig](./foundation-comms.httppollingconfig.md) | Configuration options for http connection. |
|  [HttpRequestInit](./foundation-comms.httprequestinit.md) | The options object used when making an HTTP request. |
|  [JsonSchemaCache](./foundation-comms.jsonschemacache.md) | A JSON schema cache definition |
|  [LogoutResult](./foundation-comms.logoutresult.md) | Represents the result of a user logout operation. |
|  [MessageBuilder](./foundation-comms.messagebuilder.md) | A utility class for building different types of messages. |
|  [MetadataCache](./foundation-comms.metadatacache.md) | A Metadata cache definition |
|  [PollingConfiguration](./foundation-comms.pollingconfiguration.md) | Configuration options for http polling. |
|  [Serializer](./foundation-comms.serializer.md) | A Serializer interface for serializing and deserializing objects. |
|  [Session](./foundation-comms.session.md) | Represents a session storage and its capabilities. Provides methods to set and get items from the specified storage. |
|  [Socket](./foundation-comms.socket.md) | Represents a WebSocket used to establish a communication channel between client and a Genesis server. Provides methods for socket connection, sending and receiving WS messages. |
|  [User](./foundation-comms.user.md) | Represents a User object with associated permissions and profiles. |

## Namespaces

|  Namespace | Description |
|  --- | --- |
|  [FoundationAnalyticsEvent](./foundation-comms.foundationanalyticsevent.md) | Namespace for all Analytics event types |
|  [MessageDetails](./foundation-comms.messagedetails.md) | Namespace for all Message detail types |

## Variables

|  Variable | Description |
|  --- | --- |
|  [credentialSeparator](./foundation-comms.credentialseparator.md) | The default separator used for splitting credential parts. |
|  [defaultConnectConfig](./foundation-comms.defaultconnectconfig.md) | The default configuration for connecting to a WS service. |
|  [defaultCredentialManagerConfig](./foundation-comms.defaultcredentialmanagerconfig.md) | The default configuration for the CredentialManager service. |
|  [defaultCredentialRequestOptions](./foundation-comms.defaultcredentialrequestoptions.md) | The default request options for the CredentialManager service. |
|  [defaultDatasourceConfig](./foundation-comms.defaultdatasourceconfig.md) | The default configuration for the Datasource service. |
|  [defaultHttpConnectConfig](./foundation-comms.defaulthttpconnectconfig.md) | The default configuration for connecting to an HTTP service. |
|  [exponentialScheduler](./foundation-comms.exponentialscheduler.md) | Expontential Interval scheduler for reconnect |
|  [extractFieldDefinitions](./foundation-comms.extractfielddefinitions.md) | Extracts the field definitions from the metadata. |
|  [isWebSocketExpression](./foundation-comms.iswebsocketexpression.md) | Regular Expression to test valid WebSocket (wss and ws) hosts |
|  [linearScheduler](./foundation-comms.linearscheduler.md) | Linear Interval scheduler for reconnect |
|  [logger](./foundation-comms.logger.md) | Logger for the foundation-comms package |
|  [MAX\_RECONNECT\_ATTEMPTS](./foundation-comms.max_reconnect_attempts.md) | Default number of reconnect attempts |
|  [messageOrThrow](./foundation-comms.messageorthrow.md) | Check if the provided message contains an error and throw an Error if it does |
|  [retryInterval](./foundation-comms.retryinterval.md) | Generate reconnect interval based on scheduler |
|  [toFieldMetadata](./foundation-comms.tofieldmetadata.md) | Converts the field definitions to field metadata. |
|  [TYPES\_MAP](./foundation-comms.types_map.md) | Types map for FieldTypeEnum. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [AuthInfo](./foundation-comms.authinfo.md) | Union type of all authentication information types. |
|  [BasicAuthInfo](./foundation-comms.basicauthinfo.md) | Represents basic authentication information. |
|  [BasicCredentialsInput](./foundation-comms.basiccredentialsinput.md) | Represents basic credentials for a user. |
|  [CommitParams](./foundation-comms.commitparams.md) | Parameters for a COMMIT message |
|  [ConnectionStatus](./foundation-comms.connectionstatus.md) | The connection status of the Genesis client. |
|  [CredentialData\_2](./foundation-comms.credentialdata_2.md) | Represents user credentials. |
|  [FDC3ContextHandler](./foundation-comms.fdc3contexthandler.md) |  |
|  [FDC3Intents](./foundation-comms.fdc3intents.md) |  |
|  [FieldMetadata](./foundation-comms.fieldmetadata.md) | Field Metadata definition. |
|  [FilteredDataServerResult](./foundation-comms.filtereddataserverresult.md) | Fitlered result after initial DATASERVER data fetch. |
|  [GetCredentialOptions](./foundation-comms.getcredentialoptions.md) | Represents options for retrieving credentials. |
|  [IndexDetail](./foundation-comms.indexdetail.md) | Index Detail definition. |
|  [JwtAuthInfo](./foundation-comms.jwtauthinfo.md) | Represents JWT authentication information. |
|  [LoginResult](./foundation-comms.loginresult.md) | Represents the result of a user login operation. |
|  [Message](./foundation-comms.message.md) | Base Message type for all DETAIL variants |
|  [MessageError](./foundation-comms.messageerror.md) | Error definition for a message result |
|  [MetaCache](./foundation-comms.metacache.md) | Union type of MetadataCache and JsonSchemaCache |
|  [Metadata](./foundation-comms.metadata.md) | Metadata definition for a given resource. |
|  [MetadataDetail](./foundation-comms.metadatadetail.md) | Metadata Detail definition. |
|  [RawDataServerResult](./foundation-comms.rawdataserverresult.md) | Raw result from a DATASERVER data fetch. |
|  [RefreshAuthInfo](./foundation-comms.refreshauthinfo.md) | Represents refresh token authentication information. |
|  [RefreshCredentialsInput](./foundation-comms.refreshcredentialsinput.md) | Represents refresh credentials for a user. |
|  [RequestParams](./foundation-comms.requestparams.md) | Parameters for a REQUEST message |
|  [RequestServerResult](./foundation-comms.requestserverresult.md) | Raw result from a REQUEST\_SERVER data fetch. |
|  [RowData](./foundation-comms.rowdata.md) | Row Data definition. |
|  [SchemaResponse](./foundation-comms.schemaresponse.md) | Schema Response definition. |
|  [ServerRow](./foundation-comms.serverrow.md) | Server Row definition. |
|  [SocketConnectOptions](./foundation-comms.socketconnectoptions.md) | The Socket connection options definition. |
|  [SocketReconnectOptions](./foundation-comms.socketreconnectoptions.md) | Socket reconnection options |
|  [SocketReconnectScheduler](./foundation-comms.socketreconnectscheduler.md) | Socket reconnection scheduler |
|  [SsoAuthInfo](./foundation-comms.ssoauthinfo.md) | Represents SSO authentication information. |
|  [SSOCredentialsInput](./foundation-comms.ssocredentialsinput.md) | Represents SSO credentials for a user. |
|  [StorageType](./foundation-comms.storagetype.md) | The available browser storage types. |

